package com.example.survey.controller;

import com.example.survey.enumeration.ResultEnum;
import com.example.survey.service.AuditService;
import com.example.survey.vo.ResultVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

/**
 * @author Pope
 */
@RestController
@RequestMapping("/audit")
public class AuditController {

    @Autowired
    private AuditService auditService;

    @GetMapping("/audit")
    public ResultVO getAudit(@RequestParam(value = "beginTime",required = false, defaultValue = "0") long beginTime,
                             @RequestParam(value = "endTime",required = false, defaultValue = "0") long endTime,
                             @RequestParam(value = "uri",required = false) String uri,
                             @RequestParam(value = "currentPage", defaultValue = "0") int currentPage,
                             @RequestParam(value = "pageSize", defaultValue = "30") int pageSize) {
        ResultVO resultVO = new ResultVO(ResultEnum.SUCCESS);
        resultVO.setData(auditService.listAuditLimit(beginTime, endTime, uri, currentPage, pageSize));
        return resultVO;
    }

}
