package com.example.survey.controller;

import com.example.survey.dto.metaData.CreateMetaDataDTO;
import com.example.survey.dto.metaData.DeleteMetaDataDTO;
import com.example.survey.dto.metaData.ModifyMetaDataDTO;
import com.example.survey.enumeration.MetaDataTypeEnum;
import com.example.survey.enumeration.ResultEnum;
import com.example.survey.service.MetaDataService;
import com.example.survey.vo.ResultVO;

import org.apache.commons.lang3.EnumUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Pope
 */
@RestController
@RequestMapping("/metaData")
public class MetaDataController {

    @Autowired
    MetaDataService metaDataService;

    @PostMapping("/metaData")
    public ResultVO createMetaData(@RequestBody CreateMetaDataDTO createMetaDataDTO){
        metaDataService.createMetaData(createMetaDataDTO);
        return new ResultVO(ResultEnum.SUCCESS);
    }

    @GetMapping("/nameList")
    public ResultVO listMetaData(
                                @RequestParam(value = "type",required = false) String type,
                                @RequestParam(value = "name",required = false) String name,
                                @RequestParam(value = "currentPage",defaultValue = "0")int currentPage,
                                @RequestParam(value = "pageSize",defaultValue = "30")int pageSize){

        // if (type != null && (! EnumUtils.isValidEnum(MetaDataTypeEnum.class, type))) {
        //     ResultVO resultVO = new ResultVO(ResultEnum.NOT_EXIST_METADATA);
        //     resultVO.setMsg("元数据类型不存在");
        //     return resultVO;
        // }
        Map<String, Object> resultMap = new HashMap<>(16,0.75F);
        resultMap.put("totalCount", metaDataService.countMetaData(name, type));
        resultMap.put("currentPage", currentPage);
        resultMap.put("pageSize", pageSize);
        resultMap.put("data", metaDataService.listMetaDataNameLimit(name, type ,currentPage,pageSize));

        ResultVO resultVO = new ResultVO(ResultEnum.SUCCESS);
        resultVO.setData(resultMap);
        return resultVO;
    }

    @PutMapping("/metaData")
    public ResultVO modifyMetaData(@RequestBody ModifyMetaDataDTO modifyMetaDataDTO){
        metaDataService.modifyMetaData(modifyMetaDataDTO);
        return new ResultVO(ResultEnum.SUCCESS);
    }

    @GetMapping("/metaData")
    public ResultVO getMetaData(@RequestParam("name")String name){
        ResultVO resultVO = new ResultVO();
        resultVO.setData(metaDataService.getMetaData(name));
        return resultVO;
    }

    @DeleteMapping("/metaData")
    public ResultVO deleteMetaData(@RequestBody DeleteMetaDataDTO deleteMetaDataDTO){
        metaDataService.deleteMetaData(deleteMetaDataDTO);
        return new ResultVO(ResultEnum.SUCCESS);
    }

}
