package com.example.survey.dao;

import com.example.survey.entity.MetaData;
import com.example.survey.enumeration.MetaDataTypeEnum;

import java.util.List;

/**
 * @author Pope
 */
public interface MetaDataDao {

    /**
     * 判断元数据是否存在
     *
     * @param name 元数据名
     * @return 是否存在
     */
    boolean existMetaData(String name);

    /**
     * 查询元数据
     *
     * @param name 元数据名
     * @return 元数据
     */
    MetaData selectMetaData(String name);

    /**
     * 创建元数据，若已有元数据则更新
     *
     * @param metaData 元数据
     */
    void saveMetaData(MetaData metaData);

    /**
     *
     *
     * @param name 元数据名
     * @param offset 偏移量
     * @param pageSize 页大小
     * @return 元数据
     */
    List<MetaData> listMetaDataLimit(String name, String type,  int offset, int pageSize);

    /**
     * 根据元数据名查询数量
     *
     * @param name 元数据名
     * @return 数量
     */
    long countMetaData(String name, String type);

    /**
     * 获取所有元数据
     * @return 元数据列表
     */
    List<MetaData> selectAllMetaData();

    /**
     * 删除元数据
     *
     * @param name 名字
     */
    void deleteMetaData(String name);
}
