package com.example.survey.dao;

import com.example.survey.entity.Project;
import com.example.survey.entity.Record;

import java.util.List;

/**
 * @author Pope
 */
public interface ProjectDao {


    /**
     * 根据项目名查询项目是否存在
     *
     * @param name 项目名
     * @return 项目是否存在
     */
    boolean existProject(String name);

    /**
     * 根据项目名查询项目
     *
     * @param name 项目名
     * @return 项目
     */
    Project selectProject(String name);

    /**
     * 插入项目
     *
     * @param project 项目
     */
    void saveProject(Project project);

    /**
     * 根绝筛选条件分页查询项目
     *
     * @param name 项目名
     * @param state 状态
     * @param offset 偏移量
     * @param pageSize 页大小
     * @return 项目列表
     */
    List<Project> listProjectLimit(String name, long date_gt, long date_lt, int offset, int pageSize);

    /**
     * 根据项目名查询数量
     *
     * @param name 项目名
     * @param state 状态
     * @return 数量
     */
    long countProject(String name, long date_gt, long date_lt);


}
