package com.example.survey.dao;

import com.example.survey.entity.Role;

import java.util.List;

/**
 * @author Pope
 */
public interface RoleDao {

    /**
     * 插入新角色，如果已有角色则更新
     *
     * @param role 新角色
     * @return 是否插入成功
     */
    void saveRole(Role role);

    /**
     * 根据权限名查询对应权限
     *
     * @param name 权限名
     * @return 查询结果
     */
    Role selectRole(String name);

    /**
     * 根据权限名删除权限
     *
     * @param name 权限名
     */
    void deleteRole(String name);

    /**
     * 根据角色名模糊匹配角色
     *
     * @param name     角色名  模糊匹配
     * @param offset   偏移量
     * @param pageSize 页大小
     * @return 角色列表
     */
    List<Role> listRoleLimit(String name, int offset, int pageSize);


    /**
     * 根据角色名模糊查询角色数量
     *
     * @param name 角色名
     * @return 角色数量
     */
    long countRole(String name);

    /**
     * 根据角色名判断角色是否存在
     *
     * @param name 角色名
     * @return 是否存在
     */
    boolean existRole(String name);
}
