package com.example.survey.dao.impl;

import com.example.survey.dao.AuditDao;
import com.example.survey.entity.Audit;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * @author Pope
 */
@Repository
public class AuditDaoImpl implements AuditDao {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Override
    public void saveAudit(Audit audit) {
        mongoTemplate.save(audit);
    }

    @Override
    public List<Audit> listAuditLimit(long beginTime, long endTime, String uri, int offset, int pageSize) {
        Criteria criteria = new Criteria();
        if (uri != null) {
            criteria.and("uri").is(uri);
        }
        if (beginTime != 0) {
            criteria.and("timestamp").gte(beginTime);
        }
        if (endTime != 0) {
            criteria.and("timestamp").lte(endTime);
        }
        Query query = new Query(criteria).skip(offset).limit(pageSize);
        return mongoTemplate.find(query, Audit.class);
    }
}
