package com.example.survey.dao.impl;

import com.example.survey.dao.DepartmentDao;
import com.example.survey.entity.Department;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;
/**
 * @author Pope
 */
@Log4j2
@Repository
public class DepartmentDaoImpl implements DepartmentDao {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Override
    public boolean insertDepartment(Department department) {
        try {
            mongoTemplate.save(department);
        }catch (Exception e){
        }
        return true;
    }

    @Override
    public Department selectDepartment(String id) {
        Query query = new Query(Criteria.where("id").is(id));
        return mongoTemplate.findOne(query,Department.class);
    }
}
