package com.example.survey.dto.role;

import com.example.survey.entity.Role;
import com.example.survey.enumeration.AuthEnum;
import lombok.*;

import java.util.HashSet;
import java.util.Set;

/**
 * @author Pope
 */
@Getter
@Setter
@ToString
@NoArgsConstructor
@AllArgsConstructor
public class CreateRoleDTO {
    private String name;
    private Set<String> authoritySet;

    public CreateRoleDTO(Role role) {
        name = role.getName();
        authoritySet = new HashSet<>();
        for (AuthEnum authEnum : role.getAuthoritySet()) {
            authoritySet.add(authEnum.getName());
        }
    }
}
