package com.example.survey.entity;

import lombok.*;
import org.bson.types.ObjectId;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;


import java.util.Date;
import java.util.Map;
import java.util.Set;

/**
 * @author Pope
 */
@Data
@Document(collection = "project")
public class Project {

    /**
     * id
     */
    @Id
    private ObjectId id;

    /**
     * 项目名
     */
    @Indexed(unique = true)
    private String name;

    private long date;

    private User user;

    private long count;
}
