package com.example.survey.entity;

import com.example.survey.entity.inner.Operation;
import com.example.survey.enumeration.MetaDataTypeEnum;
import com.example.survey.enumeration.RecordStateEnum;

import lombok.*;
import org.bson.types.ObjectId;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;


import java.util.List;
import java.util.Map;

/**
 * @author Pope
 * 调查记录表
 */
@Data
@Document(collection = "record")
public class Record {

    @Id
    private ObjectId id;

    @Indexed(unique = true)
    private String uuid;

    private String idNumber;

    /**
     * 用于存放前端传的字段
     */
    private Map<String, Object> values;

    /**
     * 分配的用户
     */
    @DBRef
    private User user;

    /**
     * 操作列表
     */
    private List<Operation> operationList;

    /**
     * 记录状态
     */
    private String state;

    @DBRef
    private MetaData metaData;

    private String metaDataType;

    private List<String> projectList;

    private long submitTime;

}

