package com.example.survey.enumeration;

/**
 * @author Pope
 * 调查记录状态枚举
 */

public enum RecordStateEnum {
    /**
     * 已审核状态
     */
    REVIEWED("已通过"),
    /**
     * 待审核状态
     */
    UNDER_REVIEW("待审核"),
    /**
     * 未通过状态
     */
    NOT_PASS("未通过"),
    /**
     * 已归档状态
     */
    FILED("已归档")
    ;


    private final String value;

    RecordStateEnum(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }
}
