package com.example.survey.enumeration;

/**
 * @author Pope
 */
public enum ResultEnum {
    /**
     * 请求成功
     */
    SUCCESS(0, "请求成功！"),


    NO_TOKEN(100, "请先登录！"),
    INSUFFICIENT_PRIVILEGE(101, "非法token或权限不够！"),
    NOT_EXIST_AUTHORITY(102, "权限不存在！"),

    /**
     * 用户模块
     */
    WRONG_PASSWORD(200, "密码错误！"),
    NOT_EXIST_USER(201, "用户不存在！"),
    ALREADY_EXIST_USER(202, "用户已存在！"),

    /**
     * 角色模块
     */
    NOT_EXIST_ROLE(300, "角色不存在！"),
    ALREADY_EXIST_ROLE(301, "角色已存在！"),


    /**
     * 调查对象模块
     */
    NOT_EXIST_RESPONDENT(400, "调查对象不存在！"),
    ALREADY_EXIST_RESPONDENT(401, "调查对象已存在！"),


    /**
     * 调查记录模块
     */
    NOT_EXIST_RECORD(500, "调查记录不存在！"),


    /**
     * 调查记录模块
     */
    NOT_EXIST_PROJECT(600, "项目不存在！"),
    ALREADY_EXIST_PROJECT(601, "项目已存在！"),
    NOT_EXIST_PROJECT_STATE(602, "项目状态不存在！"),

    /**
     * 元数据模块
     */
    NOT_EXIST_METADATA(700,"元数据不存在！"),
    ALREADY_EXIST_METADATA(601,"元数据已存在!"),
    ;


    private final int code;
    private final String msg;

    ResultEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public int getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }
}
