package com.example.survey.service;

import com.example.survey.dto.role.CreateRoleDTO;
import com.example.survey.dto.role.DeleteRoleDTO;
import com.example.survey.dto.role.ModifyRoleDTO;

import java.util.List;

/**
 * @author Pope
 */
public interface RoleService {

    /**
     * 创建角色
     *
     * @param createRoleDTO 角色信息
     * @return 是否创建成功
     */
    void addRole(CreateRoleDTO createRoleDTO);

    /**
     * 根据权限名分页查询权限
     *
     * @param name    角色名 模糊匹配
     * @param currentPage 当前页数
     * @param pageSize    页大小
     * @return 查询结果
     */
    List<CreateRoleDTO> listRoleLimit(String name, int currentPage, int pageSize);

    /**
     * 删除角色
     *
     * @param deleteRoleDTO 删除信息
     */
    void deleteRole(DeleteRoleDTO deleteRoleDTO);

    /**
     * 修改角色权限
     *
     * @param modifyRoleDTO 修改信息
     */
    void modifyRole(ModifyRoleDTO modifyRoleDTO);

    /**
     * 根绝角色名模糊查询角色数量
     *
     * @param name  角色名 模糊匹配
     * @return 角色数量
     */
    long countRole(String name);
}
