package com.example.survey.service.impl;

import com.example.survey.dao.AuditDao;
import com.example.survey.service.AuditService;
import com.example.survey.vo.AuditVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author Pope
 */
@Service
public class AuditServiceImpl implements AuditService {

    @Autowired
    AuditDao auditDao;

    @Override
    public List<AuditVO> listAuditLimit(long beginTime, long endTime, String uri, int currentPage, int pageSize) {
        return auditDao.listAuditLimit(beginTime, endTime, uri, currentPage * pageSize, pageSize).stream()
                .map(audit -> {
                    AuditVO auditVO = new AuditVO();
                    auditVO.setIp(audit.getIp());
                    auditVO.setTimestamp(audit.getTimestamp());
                    auditVO.setUri(audit.getUri());
                    auditVO.setUserPhone(audit.getUserPhone());
                    return auditVO;
                }).collect(Collectors.toList());
    }
}
